| OpendTect 8.0

Loading...
Searching...
No Matches
Public Member Functions | Protected Member Functions | Protected Attributes | List of all members
HorizonSorter Class Reference
EarthModel

Executor to sort horizons. More...

`#include <horizonsorter.h>`

Inheritance diagram for HorizonSorter:
[legend]

## Public Member Functions
| HorizonSorter (const TypeSet< EM::ObjectID > &, bool is2d=false)
| HorizonSorter (const TypeSet< MultiID > &, bool is2d=false)
| ~HorizonSorter ()
const TrcKeySampling & | getBoundingBox () const
int | getNrCrossings (const EM::ObjectID, const EM::ObjectID) const
int | getNrCrossings (const MultiID &, const MultiID &) const
void | getSortedList (TypeSet< EM::ObjectID > &)
void | getSortedList (TypeSet< MultiID > &)
od_int64 | nrDone () const override
void | setTaskRunner (TaskRunner &)
od_int64 | totalNr () const override
uiString | uiMessage () const override
uiString | uiNrDoneText () const override
Public Member Functions inherited from Executor
| Executor (const char *nm)
virtual | ~Executor ()
int | doStep () override
bool | execute () override
bool | go (od_ostream &s, bool isfirst=true, bool islast=true, int delaybtwnstepsinms=0)
bool | go (od_ostream *s=0, bool isfirst=true, bool islast=true, int delaybtwnstepsinms=0)
Public Member Functions inherited from SequentialTask
| SequentialTask (const char *nm=nullptr)
virtual | ~SequentialTask ()
bool | execute () override
Public Member Functions inherited from ReportingTask
| ReportingTask (const ReportingTask &)=delete
virtual | ~ReportingTask ()
void | getProgress (const ReportingTask &)
ReportingTask & | operator= (const ReportingTask &)=delete
void | setSimpleMeter (bool yn, int repperc)
int | simpleMeterStep () const
bool | useSimpleMeter () const
Public Member Functions inherited from Task
| Task (const Task &)=delete
virtual | ~Task ()
virtual void | controlWork (Control)
virtual void | enableWorkControl (bool=true)
| Must be called before execute()
virtual uiRetVal | errorWithDetails () const
virtual Control | getState () const
Task & | operator= (const Task &)=delete
bool | workControlEnabled () const
Public Member Functions inherited from NamedCallBacker
| NamedCallBacker (const char *nm=nullptr)
| NamedCallBacker (const NamedCallBacker &)=delete
| ~NamedCallBacker ()
virtual Notifier< NamedCallBacker > & | objectToBeDeleted () const
NamedCallBacker & | operator= (const NamedCallBacker &)=delete
bool | operator== (const NamedCallBacker &oth) const
bool | operator== (const NamedObject &oth) const
Public Member Functions inherited from CallBacker
| CallBacker ()
| CallBacker (const CallBacker &)
virtual | ~CallBacker ()
bool | attachCB (const NotifierAccess &, const CallBack &, bool onlyifnew=false) const
bool | attachCB (const NotifierAccess *notif, const CallBack &cb, bool onlyifnew=false) const
void | detachAllNotifiers () const
| Call from the destructor of your inherited object.
void | detachCB (const NotifierAccess &, const CallBack &) const
void | detachCB (const NotifierAccess *notif, const CallBack &cb) const
virtual bool | isCapsule () const
bool | isNotifierAttached (const NotifierAccess *) const
| Only for debugging purposes, don't use.
CallBacker & | operator= (const CallBacker &)=delete
void | stopReceivingNotifications () const
virtual CallBacker * | trueCaller ()
Public Member Functions inherited from NamedObject
| NamedObject (const char *nm=nullptr)
| NamedObject (const NamedObject &oth)
virtual | ~NamedObject ()
virtual BufferString | getName () const
bool | getNameFromPar (const IOPar &)
const name_type & | name () const override
NamedObject & | operator= (const NamedObject &)
bool | operator== (const NamedObject &oth) const
virtual void | setName (const char *nm)
Public Member Functions inherited from ObjectWithName
virtual | ~ObjectWithName ()
bool | hasName (const char *nm) const
bool | hasName (const name_type &nm) const
void | putNameInPar (IOPar &) const

## Protected Member Functions
void | calcBoundingBox ()
void | init ()
int | nextStep () override
void | sort ()
Protected Member Functions inherited from Executor
virtual bool | goImpl (od_ostream *, bool, bool, int)
Protected Member Functions inherited from SequentialTask
virtual bool | doFinish (bool success, od_ostream *=nullptr)
virtual bool | doPrepare (od_ostream *=nullptr)
Protected Member Functions inherited from ReportingTask
| ReportingTask (const char *nm=nullptr)
void | incrementProgress ()
ProgressMeter * | progressMeter () const
void | reportProgressFinished ()
void | reportProgressStarted ()
void | resetProgress ()
void | setProgressMeter (ProgressMeter *) override
| Must be called before execute()
void | updateProgressMeter (bool forced=false, od_int64 *totalnr=0)
void | updateReportedName ()
Protected Member Functions inherited from Task
| Task (const char *nm=nullptr)
virtual bool | shouldContinue ()
Protected Member Functions inherited from NamedCallBacker
void | sendDelNotif () const

## Protected Attributes
BinID | binid_
TypeSet< Pos::GeomID > | geomids_
ObjectSet< EM::Horizon > | horizons_
bool | is2d_
TrcKeySamplingIterator * | iterator_ = nullptr
uiString | message_
int | nrdone_ = 0
Array3D< int > * | resultcount_ = nullptr
Array3D< double > * | resultzsum_ = nullptr
TypeSet< EM::ObjectID > | sortedids_
TypeSet< MultiID > | sortedkeys_
TaskRunner * | taskrun_ = nullptr
TrcKeySampling | tks_
int | totalnr_ = -1
TypeSet< StepInterval< int > > | trcrgs_
TypeSet< EM::ObjectID > | unsortedids_
TypeSet< MultiID > | unsortedkeys_
Protected Attributes inherited from Task
Control | control_ = Task::Run
Threads::ConditionVar * | workcontrolcondvar_ = nullptr
Protected Attributes inherited from NamedCallBacker
Threads::Atomic< bool > | delalreadytriggered_
Notifier< NamedCallBacker > | delnotif_
Protected Attributes inherited from NamedObject
BufferString | name_

## Additional Inherited Members
Public Types inherited from Task
enum | Control { Run , Pause , Stop }
Public Types inherited from ObjectWithName
typedef OD::String | name_type
Static Public Member Functions inherited from SequentialTask
static int | ErrorOccurred ()
static int | Finished ()
static int | MoreToDo ()
static int | WarningAvailable ()
Static Public Member Functions inherited from ReportingTask
static PtrMan< ProgressMeter > | getTextProgressMeter (od_ostream &, const IOPar *iop=nullptr)
static bool | needSimpleLogging (const IOPar &)
static const char * | sKeySimpleLogging ()
static const char * | sKeySimpleLoggingStep ()
Static Public Member Functions inherited from Task
static uiString | uiStdNrDoneText ()
Static Public Member Functions inherited from CallBacker
static void | createReceiverForCurrentThread ()
static void | removeReceiverForCurrentThread ()
Public Attributes inherited from Executor
Notifier< Executor > | poststep
| Only when MoreToDo will be returned.
Notifier< Executor > | prestep
Public Attributes inherited from ReportingTask
Notifier< ReportingTask > | progressUpdated

## Detailed Description

Executor to sort horizons.

<>

## Constructor & Destructor Documentation

## ◆ HorizonSorter() [1/2]

HorizonSorter::HorizonSorter | ( | const TypeSet< MultiID > & | ,
|  | bool | is2d = false )

## ◆ HorizonSorter() [2/2]

HorizonSorter::HorizonSorter | ( | const TypeSet< EM::ObjectID > & | ,
|  | bool | is2d = false )

## ◆ ~HorizonSorter()

HorizonSorter::~HorizonSorter | ( |  | ) |

## Member Function Documentation

## ◆ calcBoundingBox()

void HorizonSorter::calcBoundingBox | ( |  | ) |
| protected

## ◆ getBoundingBox()

const TrcKeySampling & HorizonSorter::getBoundingBox | ( |  | ) | const
| inline

## ◆ getNrCrossings() [1/2]

int HorizonSorter::getNrCrossings | ( | const EM::ObjectID | ,
|  | const EM::ObjectID | ) const

## ◆ getNrCrossings() [2/2]

int HorizonSorter::getNrCrossings | ( | const MultiID & | ,
|  | const MultiID & | ) const

## ◆ getSortedList() [1/2]

void HorizonSorter::getSortedList | ( | TypeSet< EM::ObjectID > & |  | ) |

## ◆ getSortedList() [2/2]

void HorizonSorter::getSortedList | ( | TypeSet< MultiID > & |  | ) |

## ◆ init()

void HorizonSorter::init | ( |  | ) |
| protected

## ◆ nextStep()

int HorizonSorter::nextStep | ( |  | ) |
| override protected virtual

Return values

  MoreToDo() | Not finished. Call me again.
  Finished() | Nothing more to do.
  ErrorOccurred() | Something went wrong.

Note
  if function returns a value greater than cMoreToDo(), it should be interpreted as cMoreToDo().

Implements SequentialTask.

## ◆ nrDone()

od_int64 HorizonSorter::nrDone | ( |  | ) | const
| override virtual

Note
  nrDone is only used for displaying progress and will be compared to totalNr to show user how large part of the task that is finished.

Reimplemented from Task.

## ◆ setTaskRunner()

void HorizonSorter::setTaskRunner | ( | TaskRunner & |  | ) |

## ◆ sort()

void HorizonSorter::sort | ( |  | ) |
| protected

## ◆ totalNr()

od_int64 HorizonSorter::totalNr | ( |  | ) | const
| override virtual

Reimplemented from Task.

## ◆ uiMessage()

uiString HorizonSorter::uiMessage | ( |  | ) | const
| override virtual

Reimplemented from Task.

## ◆ uiNrDoneText()

uiString HorizonSorter::uiNrDoneText | ( |  | ) | const
| override virtual

Reimplemented from Task.

## Member Data Documentation

## ◆ binid_

BinID HorizonSorter::binid_
| protected

## ◆ geomids_

TypeSet<Pos::GeomID> HorizonSorter::geomids_
| protected

## ◆ horizons_

ObjectSet<EM::Horizon> HorizonSorter::horizons_
| protected

## ◆ is2d_

bool HorizonSorter::is2d_
| protected

## ◆ iterator_

TrcKeySamplingIterator* HorizonSorter::iterator_ = nullptr
| protected

## ◆ message_

uiString HorizonSorter::message_
| protected

## ◆ nrdone_

int HorizonSorter::nrdone_ = 0
| protected

## ◆ resultcount_

Array3D<int>* HorizonSorter::resultcount_ = nullptr
| protected

## ◆ resultzsum_

Array3D<double>* HorizonSorter::resultzsum_ = nullptr
| protected

## ◆ sortedids_

TypeSet<EM::ObjectID> HorizonSorter::sortedids_
| protected

## ◆ sortedkeys_

TypeSet<MultiID> HorizonSorter::sortedkeys_
| protected

## ◆ taskrun_

TaskRunner* HorizonSorter::taskrun_ = nullptr
| protected

## ◆ tks_

TrcKeySampling HorizonSorter::tks_
| protected

## ◆ totalnr_

int HorizonSorter::totalnr_ = -1
| protected

## ◆ trcrgs_

TypeSet<StepInterval<int> > HorizonSorter::trcrgs_
| protected

## ◆ unsortedids_

TypeSet<EM::ObjectID> HorizonSorter::unsortedids_
| protected

## ◆ unsortedkeys_

TypeSet<MultiID> HorizonSorter::unsortedkeys_
| protected

Generated at
for the OpendTect seismic interpretation project. Copyright (C): dGB Beheer B.V. 1995-2025